<template>
   <div>
      <div class="section">
         <div class="container">
            <div class="columns">
               <div class="column">
                  <div class="profile-items">
                     <div class="columns is-multiline">
                        <div class="column is-one-third">
                           <nuxt-link to="/add" class="button is-primary is-outlined" style="height: 100%;width: 100%;">
                              <div class="content">
                                 <p><span class="icon"><i class="fa fa-plus"></i></span></p>
                                 <p>
                                    ADD TOPIC
                                 </p>
                              </div>
                           </nuxt-link>
                        </div>
                        
                        
                        <!-- for each topic, create card --> 
                        <div class="column is-one-third" v-for="topic in topics.slice().reverse()" v-bind:key="topic.key"> 
                        <!-- div class="column is-one-third" v-for="topic in topics.slice().reverse()" v-bind:key="topic.key" -->
                           <div class="card">
                              <header class="card-header">
                                <p class="card-header-title">
                                  {{topic.topic}}
                                </p>
                                
                              </header>
                              <div class="card-content">
                                        <div class="media">
                                          <div class="media-content">
                                            
                                          </div>
                                        </div>
                                  
                                <div class="content box">
                                  {{topic.msg}}
                                
                                </div>
                                <small class="">@{{topic.creator.name}}</small>
                                <br>
                                <small class="timeago" :datetime="topic.timeposted"></small>
                                  
                                <div class="tags has-addons">
                                        <span class="tag">Repost</span> 
                                        <span class="tag is-info">{{topic.reposts}}</span>
                                </div> 

                                    <div class="has-text-centered">
                                      <a v-if="topic.creator.uid != uid" class="button is-fullwidth is-primary raised is-clear" @click="shout(topic)">Chat</a>
                                      <a v-else class="button is-fullwidth" disabled>Chat</a>
                                    </div>
                                
                              </div>
                            </div>
                        </div>
                         
                         
                        <div class="column is-one-third" v-show="topics.length == 0">
                           <div class="">
                              <div class="card-content">
                                  
                                <div class="has-text-centered">
                                  
                                  
                                  
                                <div class="sk-cube-grid">
                                  <div class="sk-cube sk-cube1"></div>
                                  <div class="sk-cube sk-cube2"></div>
                                  <div class="sk-cube sk-cube3"></div>
                                  <div class="sk-cube sk-cube4"></div>
                                  <div class="sk-cube sk-cube5"></div>
                                  <div class="sk-cube sk-cube6"></div>
                                  <div class="sk-cube sk-cube7"></div>
                                  <div class="sk-cube sk-cube8"></div>
                                  <div class="sk-cube sk-cube9"></div>
                                </div>
                                
                                <p>waiting for topics to be posted </p>

                                </div>
                              </div>
                            </div>
                        </div>
                     </div>
                  </div>
               </div>
            </div>
         </div>
      </div>
   </div>
</template>

<script>
import { DB } from '@/plugins/firebase.js';
import timeago from 'timeago.js';

export default {
    data: function () {
        return {
            topics: [],
            uid: this.$store.getters.isAuthenticated,
            name: this.$store.getters.name
        }
    },
    methods: {
        loadTopics: function () {
          var ref = DB.ref().child('topics/')
          var openTopics = ref.orderByChild("state").equalTo('1');
          openTopics.on('child_added', (data) => {
                // push the snapshot value into a data attribute
                this.topics.push(data.val())
                console.log(data.val())
            })    
        },
        deletedTopics: function () {
          var ref = DB.ref().child('topics/')
          var openTopics = ref.orderByChild("state").equalTo('1');
          //topic removed
          openTopics.on("child_removed", (data) => {
            var deletedPost = data.val().key;
            //var array = this.topics

              for( var i = 0; i < this.topics.length; i++){ 
                if ( this.topics[i].key == deletedPost) {
                  this.topics.splice(i, 1); 
                  console.log(deletedPost + "has been deleted");
                }
              }

          });
        },
        shout: function(topic) {
          console.log(topic.key)
          var ts = new Date().getTime()
          var msg = topic.msg
          var self = this
          var creatorId = topic.creator.uid
          var joinerId = self.uid

          console.log(creatorId)
          console.log(joinerId)

          var chatObj = {
            key: topic.key,
            creator: topic.creator,
            joiner: {
              uid: self.uid,
              name: self.name
            },
            chatstart: ts,
            msg: topic.msg,
            topic: topic.topic
          }
         
          var topic = DB.ref().child('topics/').child(topic.key)

          topic.transaction(function(chat) {
            if (!chat.joiner) {
              chat.state = 2
              chat.joiner = {
                uid: self.uid,
                name: self.name
              },
              chat.chatstart = ts
            }

            return chat
          })
          .then(function() {

              var updates = {}
              
              updates['/users/' + creatorId + '/chats/' + topic.key] = chatObj
              
              updates['/users/' + joinerId + '/chats/' + topic.key] = chatObj
              
              DB.ref().update(updates)
              .then(function() {
                self.$router.push({path: "/chat", query: { id: topic.key }})
                self.$izitoast.success({
                      title: 'Yay',
                      message: "Chat started!"
                })
                self.loading = false
                //self.$router.push('/chats')
              })
              .catch(function(error) {
                  self.$izitoast.error({
                        title: 'Uhh',
                        message: "something failed..."
                  })
              })
          })
          .catch(function(error) {
              self.$izitoast.error({
                    title: 'Uhh',
                    message: "something failed..."
              })
          })



        },
    },
    mounted () {
        this.loadTopics();
        
        this.deletedTopics();
      
    },
    updated () {
        timeago().render(document.querySelectorAll('.timeago'));
    },
    computed: {
        myTopics: function () {
            var topics = this.topics 
            var myUid = this.uid
            var myTopics = topics.filter(function(topic) {
            	return topic.author == myUid;
            })
            
            return myTopics
        },
        otherTopics: function () {
            var topics = this.topics 
            var myUid = this.uid
            var otherTopics = topics.filter(function(topic) {
            	return topic.author != myUid;
            })
            
            return otherTopics
        }
    },
    middleware: 'auth'
}

</script>

<style scoped>
    .sk-cube-grid {
  width: 40px;
  height: 40px;
  margin: 100px auto;
}

.sk-cube-grid .sk-cube {
  width: 33%;
  height: 33%;
  background-color: #333;
  float: left;
  -webkit-animation: sk-cubeGridScaleDelay 1.3s infinite ease-in-out;
          animation: sk-cubeGridScaleDelay 1.3s infinite ease-in-out; 
}
.sk-cube-grid .sk-cube1 {
  -webkit-animation-delay: 0.2s;
          animation-delay: 0.2s; }
.sk-cube-grid .sk-cube2 {
  -webkit-animation-delay: 0.3s;
          animation-delay: 0.3s; }
.sk-cube-grid .sk-cube3 {
  -webkit-animation-delay: 0.4s;
          animation-delay: 0.4s; }
.sk-cube-grid .sk-cube4 {
  -webkit-animation-delay: 0.1s;
          animation-delay: 0.1s; }
.sk-cube-grid .sk-cube5 {
  -webkit-animation-delay: 0.2s;
          animation-delay: 0.2s; }
.sk-cube-grid .sk-cube6 {
  -webkit-animation-delay: 0.3s;
          animation-delay: 0.3s; }
.sk-cube-grid .sk-cube7 {
  -webkit-animation-delay: 0s;
          animation-delay: 0s; }
.sk-cube-grid .sk-cube8 {
  -webkit-animation-delay: 0.1s;
          animation-delay: 0.1s; }
.sk-cube-grid .sk-cube9 {
  -webkit-animation-delay: 0.2s;
          animation-delay: 0.2s; }

@-webkit-keyframes sk-cubeGridScaleDelay {
  0%, 70%, 100% {
    -webkit-transform: scale3D(1, 1, 1);
            transform: scale3D(1, 1, 1);
  } 35% {
    -webkit-transform: scale3D(0, 0, 1);
            transform: scale3D(0, 0, 1); 
  }
}

@keyframes sk-cubeGridScaleDelay {
  0%, 70%, 100% {
    -webkit-transform: scale3D(1, 1, 1);
            transform: scale3D(1, 1, 1);
  } 35% {
    -webkit-transform: scale3D(0, 0, 1);
            transform: scale3D(0, 0, 1);
  } 
}
</style>
